/*
 * TwisterMain.c
 *
 * Created: 18-6-2019 03:21:07
 * Author : Wouter
 */ 


#define F_CPU   				32000000UL

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include <string.h>
#include <avr/interrupt.h>
#include <stdio.h>
#include "wouterlcd.c"

#define BLINK_DELAY_MS 1000


void SetClock();
void UpdateLeds();
void InitGPIO();
void resetArray();
void ScanKeypad();
void PlaySound (uint8_t iFileNum);
void Lost();
void resetLeds();

uint8_t Leds[96][3] = {
	{255, 0, 0},
	{255, 0, 0},
	{255, 0, 0},
	{255, 0, 0},
	
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	
	{0, 255, 0},
	{0, 255, 0},
	{0, 255, 0},
	{0, 255, 0},
	
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	
	{0, 0, 255},
	{0, 0, 255},
	{0, 0, 255},
	{0, 0, 255},
	
	
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	
	{0, 255, 255},
	{0, 255, 255},
	{0, 255, 255},
	{0, 255, 255},
	
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	
	{255, 0, 0},
	{255, 0, 0},
	{255, 0, 0},
	{255, 0, 0},
	
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	
	{0, 255, 0},
	{0, 255, 0},
	{0, 255, 0},
	{0, 255, 0},
	
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	
	{255, 0, 0},
	{255, 0, 0},
	{255, 0, 0},
	{255, 0, 0}			
};

uint8_t Keypad[25];


void resetLeds()
{
		uint8_t iLocalCount = 0;
		
		for(iLocalCount = 0; iLocalCount < 95; iLocalCount++)
		{
			Leds[iLocalCount][0] = 0;
			Leds[iLocalCount][1] = 0;
			Leds[iLocalCount][2] = 0;
		}
	

}

int main( void )
{
	uint8_t iHoi = 0;
	int iTimer = 0;
	int Score = 0;
	
	SetClock();
	InitGPIO();
	
	_delay_ms( BLINK_DELAY_MS ) ; // wait.
	
	UpdateLeds();
	UpdateLeds();
	UpdateLeds();
	UpdateLeds();
	
	LcdInit();
	LcdClear();
	LcdUpdate();
			
	LcdGotoXYFont(1,1);
	LcdStr(FONT_1X,"  Press Start");
	
	LcdUpdate();
	
	//PlaySound(1);
	resetLeds();
	while(1)
	
	{ // loop forever
		start:
		LcdClear();
		LcdUpdate();	
		LcdGotoXYFont(1,1);
		LcdStr(FONT_1X,"  Press Start");
		LcdUpdate();
		_delay_ms(5);
		Score = 0;
		
		if ((PORTC.IN & PIN2_bm) == 0)
		{
			
			//Begin	Game
			LcdClear();
			LcdUpdate();	
			LcdGotoXYFont(1,1);
			LcdStr(FONT_1X,"Lft Hnd: Blue");
			LcdGotoXYFont(1,2);
			LcdStr(FONT_1X,"Rght Hnd: Grn");
			//LcdGotoXYFont(1,4);
			LcdUpdate();
			
			//iHoi = Rnd(40);
			PORTA.OUTCLR = PIN4_bm;
			PORTA.OUTCLR = PIN3_bm;
			PlaySound(3);
			_delay_ms(2000);
			_delay_ms(3000);





			//PlaySound(2);
			Leds[12][1] = 0; Leds[12][2] = 255; Leds[12][3] = 0; Leds[13][1] = 0; Leds[13][2] = 255; Leds[13][3] = 0; 
			Leds[14][1] = 0; Leds[14][2] = 255; Leds[14][3] = 0; Leds[15][1] = 0; Leds[15][2] = 255; Leds[15][3] = 0; 
			UpdateLeds();
			iTimer = 0;
			while(iTimer < 200)
			{
				iTimer++;
				_delay_ms(10);
			}
			Leds[12][1] = 0; Leds[12][2] = 0; Leds[12][3] = 0; 	Leds[13][1] = 0; Leds[13][2] = 0; Leds[13][3] = 0; 
			Leds[14][1] = 0; Leds[14][2] = 0; Leds[14][3] = 0; 	Leds[15][1] = 0; Leds[15][2] = 0; Leds[15][3] = 0; 

			UpdateLeds();
			
			ScanKeypad();
			if (Keypad[12] == 0)
			{
				Lost();
				goto start;
			}
			
			// Display Score
			
//----------------------------------------------------------------------------------------------
			//PlaySound(2);
			Leds[91][1] = 0; Leds[91][2] = 0; Leds[91][3] = 255; 	Leds[92][1] = 0; Leds[92][2] = 0; Leds[92][3] = 255; 
			Leds[93][1] = 0; Leds[93][2] = 0; Leds[93][3] = 255; 	Leds[94][1] = 0; Leds[94][2] = 0; Leds[94][3] = 255; 
			UpdateLeds();
			iTimer = 0;
			while(iTimer < 190)
			{
				iTimer++;
				_delay_ms(10);
			}

			Leds[91][1] = 0; Leds[91][2] = 0; Leds[91][3] = 0; 	Leds[92][1] = 0; Leds[92][2] = 0; Leds[92][3] = 0; 
			Leds[93][1] = 0; Leds[93][2] = 0; Leds[93][3] = 0; 	Leds[94][1] = 0; Leds[94][2] = 0; Leds[94][3] = 0; 
			UpdateLeds();
			
			ScanKeypad();
			if (Keypad[1] == 0)
			{
				Lost();
				goto start;
			}
//----------------------------------------------------------------------------------------------


//----------------------------------------------------------------------------------------------
			//PlaySound(2);
			Leds[64][1] = 255; Leds[64][2] = 0; Leds[64][3] = 0; 	Leds[65][1] = 255; Leds[65][2] = 0; Leds[65][3] = 0; 
			Leds[66][1] = 255; Leds[66][2] = 0; Leds[66][3] = 0; 	Leds[67][1] = 255; Leds[67][2] = 0; Leds[67][3] = 0; 
			UpdateLeds();
			iTimer = 0;
			while(iTimer < 160)
			{
				iTimer++;
				_delay_ms(10);
			}

			Leds[64][1] = 0; Leds[64][2] = 0; Leds[64][3] = 0; 	Leds[65][1] = 0; Leds[65][2] = 0; Leds[65][3] = 0; 
			Leds[66][1] = 0; Leds[66][2] = 0; Leds[66][3] = 0; 	Leds[67][1] = 0; Leds[67][2] = 0; Leds[67][3] = 0; 
			UpdateLeds();
			
			ScanKeypad();
			if (Keypad[6] == 0)
			{
				Lost();
				goto start;
			}
//----------------------------------------------------------------------------------------------



		//----------------------------------------------------------------------------------------------
			//PlaySound(2);
			Leds[36][1] = 0; Leds[36][2] = 255; Leds[36][3] = 0; 	Leds[37][1] = 0; Leds[37][2] = 255; Leds[37][3] = 0; //BLue
			Leds[38][1] = 0; Leds[38][2] = 255; Leds[38][3] = 0; 	Leds[39][1] = 0; Leds[39][2] = 255; Leds[39][3] = 0; 
			UpdateLeds();
			iTimer = 0;
			while(iTimer < 150)
			{
				iTimer++;
				_delay_ms(10);
			}

			Leds[36][1] = 0; Leds[36][2] = 0; Leds[36][3] = 0; 	Leds[37][1] = 0; Leds[37][2] = 0; Leds[37][3] = 0; 
			Leds[38][1] = 0; Leds[38][2] = 0; Leds[38][3] = 0; 	Leds[39][1] = 0; Leds[39][2] = 0; Leds[39][3] = 0; 
			UpdateLeds();
			
			ScanKeypad();
			if (Keypad[11] == 0)
			{
				Lost();
				goto start;
			}
//----------------------------------------------------------------------------------------------

			
			
		
		
		
		
				//----------------------------------------------------------------------------------------------
			//PlaySound(2);
			Leds[68][1] = 0; Leds[68][2] = 255; Leds[68][3] = 0; 	Leds[69][1] = 0; Leds[69][2] = 255; Leds[69][3] = 0; //BLue
			Leds[70][1] = 0; Leds[70][2] = 255; Leds[70][3] = 0; 	Leds[71][1] = 0; Leds[71][2] = 255; Leds[71][3] = 0; 
			UpdateLeds();
			iTimer = 0;
			while(iTimer < 130)
			{
				iTimer++;
				_delay_ms(10);
			}

			Leds[68][1] = 0; Leds[68][2] = 0; Leds[68][3] = 0; 	Leds[69][1] = 0; Leds[69][2] = 0; Leds[69][3] = 0; //BLue
			Leds[70][1] = 0; Leds[70][2] = 0; Leds[70][3] = 0; 	Leds[71][1] = 0; Leds[71][2] = 0; Leds[71][3] = 0; 
			UpdateLeds();
			
			ScanKeypad();
			if (Keypad[2] == 0)
			{
				Lost();
				goto start;
			}


//----------------------------------------------------------------------------------------------
			//PlaySound(2);
			Leds[64][1] = 255; Leds[64][2] = 0; Leds[64][3] = 0; 	Leds[65][1] = 255; Leds[65][2] = 0; Leds[65][3] = 0; 
			Leds[66][1] = 255; Leds[66][2] = 0; Leds[66][3] = 0; 	Leds[67][1] = 255; Leds[67][2] = 0; Leds[67][3] = 0; 
			UpdateLeds();
			iTimer = 0;
			while(iTimer < 110)
			{
				iTimer++;
				_delay_ms(10);
			}

			Leds[64][1] = 0; Leds[64][2] = 0; Leds[64][3] = 0; 	Leds[65][1] = 0; Leds[65][2] = 0; Leds[65][3] = 0; 
			Leds[66][1] = 0; Leds[66][2] = 0; Leds[66][3] = 0; 	Leds[67][1] = 0; Leds[67][2] = 0; Leds[67][3] = 0; 
			UpdateLeds();
			
			ScanKeypad();
			if (Keypad[6] == 0)
			{
				Lost();
				goto start;
			}
//----------------------------------------------------------------------------------------------



		//----------------------------------------------------------------------------------------------
			//PlaySound(2);
			Leds[36][1] = 0; Leds[36][2] = 255; Leds[36][3] = 0; 	Leds[37][1] = 0; Leds[37][2] = 255; Leds[37][3] = 0; //BLue
			Leds[38][1] = 0; Leds[38][2] = 255; Leds[38][3] = 0; 	Leds[39][1] = 0; Leds[39][2] = 255; Leds[39][3] = 0; 
			UpdateLeds();
			iTimer = 0;
			while(iTimer < 100)
			{
				iTimer++;
				_delay_ms(10);
			}

			Leds[36][1] = 0; Leds[36][2] = 0; Leds[36][3] = 0; 	Leds[37][1] = 0; Leds[37][2] = 0; Leds[37][3] = 0; 
			Leds[38][1] = 0; Leds[38][2] = 0; Leds[38][3] = 0; 	Leds[39][1] = 0; Leds[39][2] = 0; Leds[39][3] = 0; 
			UpdateLeds();
			
			ScanKeypad();
			if (Keypad[11] == 0)
			{
				Lost();
				goto start;
			}
//----------------------------------------------------------------------------------------------

			
			
		
		
		
		
				//----------------------------------------------------------------------------------------------
			//PlaySound(2);
			Leds[68][1] = 0; Leds[68][2] = 255; Leds[68][3] = 0; 	Leds[69][1] = 0; Leds[69][2] = 255; Leds[69][3] = 0; //BLue
			Leds[70][1] = 0; Leds[70][2] = 255; Leds[70][3] = 0; 	Leds[71][1] = 0; Leds[71][2] = 255; Leds[71][3] = 0; 
			UpdateLeds();
			iTimer = 0;
			while(iTimer < 90)
			{
				iTimer++;
				_delay_ms(10);
			}

			Leds[68][1] = 0; Leds[68][2] = 0; Leds[68][3] = 0; 	Leds[69][1] = 0; Leds[69][2] = 0; Leds[69][3] = 0; //BLue
			Leds[70][1] = 0; Leds[70][2] = 0; Leds[70][3] = 0; 	Leds[71][1] = 0; Leds[71][2] = 0; Leds[71][3] = 0; 
			UpdateLeds();
			
			ScanKeypad();
			if (Keypad[2] == 0)
			{
				Lost();
				goto start;
			}
//----------------------------------------------------------------------------------------------



				//----------------------------------------------------------------------------------------------
			//PlaySound(2);
			Leds[63][1] = 0; Leds[63][2] = 0; Leds[63][3] = 255; 	Leds[64][1] = 0; Leds[64][2] = 0; Leds[64][3] = 255; //Green
			Leds[65][1] = 0; Leds[65][2] = 0; Leds[65][3] = 255; 	Leds[66][1] = 0; Leds[66][2] = 0; Leds[66][3] = 255; 
			UpdateLeds();
			iTimer = 0;
			while(iTimer < 70)
			{
				iTimer++;
				_delay_ms(10);
			}

			Leds[63][1] = 0; Leds[63][2] = 0; Leds[63][3] = 0; 	Leds[64][1] = 0; Leds[64][2] = 0; Leds[64][3] = 0; //Green
			Leds[65][1] = 0; Leds[65][2] = 0; Leds[65][3] = 0; 	Leds[66][1] = 0; Leds[66][2] = 0; Leds[66][3] = 0;  
			UpdateLeds();
			
			ScanKeypad();
			if (Keypad[6] == 0)
			{
				Lost();
				goto start;
			}
//----------------------------------------------------------------------------------------------		
		
		
	//----------------------------------------------------------------------------------------------
			//PlaySound(2);
			Leds[36][1] = 0; Leds[36][2] = 255; Leds[36][3] = 0; 	Leds[37][1] = 0; Leds[37][2] = 255; Leds[37][3] = 0; //BLue
			Leds[38][1] = 0; Leds[38][2] = 255; Leds[38][3] = 0; 	Leds[39][1] = 0; Leds[39][2] = 255; Leds[39][3] = 0; 
			UpdateLeds();
			iTimer = 0;
			while(iTimer < 60)
			{
				iTimer++;
				_delay_ms(10);
			}

			Leds[36][1] = 0; Leds[36][2] = 0; Leds[36][3] = 0; 	Leds[37][1] = 0; Leds[37][2] = 0; Leds[37][3] = 0; 
			Leds[38][1] = 0; Leds[38][2] = 0; Leds[38][3] = 0; 	Leds[39][1] = 0; Leds[39][2] = 0; Leds[39][3] = 0; 
			UpdateLeds();
			
			ScanKeypad();
			if (Keypad[11] == 0)
			{
				Lost();
				goto start;
			}
//----------------------------------------------------------------------------------------------


			//PlaySound(2);
			Leds[12][1] = 0; Leds[12][2] = 255; Leds[12][3] = 0; Leds[13][1] = 0; Leds[13][2] = 255; Leds[13][3] = 0; 
			Leds[14][1] = 0; Leds[14][2] = 255; Leds[14][3] = 0; Leds[15][1] = 0; Leds[15][2] = 255; Leds[15][3] = 0; 
			UpdateLeds();
			iTimer = 0;
			while(iTimer < 50)
			{
				iTimer++;
				_delay_ms(10);
			}
			Leds[12][1] = 0; Leds[12][2] = 0; Leds[12][3] = 0; 	Leds[13][1] = 0; Leds[13][2] = 0; Leds[13][3] = 0; 
			Leds[14][1] = 0; Leds[14][2] = 0; Leds[14][3] = 0; 	Leds[15][1] = 0; Leds[15][2] = 0; Leds[15][3] = 0; 

			UpdateLeds();
			
			ScanKeypad();
			if (Keypad[12] == 0)
			{
				Lost();
				goto start;
			}
			
			// Display Score
			
//----------------------------------------------------------------------------------------------
			//PlaySound(2);
			Leds[91][1] = 0; Leds[91][2] = 0; Leds[91][3] = 255; 	Leds[92][1] = 0; Leds[92][2] = 0; Leds[92][3] = 255; 
			Leds[93][1] = 0; Leds[93][2] = 0; Leds[93][3] = 255; 	Leds[94][1] = 0; Leds[94][2] = 0; Leds[94][3] = 255; 
			UpdateLeds();
			iTimer = 0;
			while(iTimer < 55)
			{
				iTimer++;
				_delay_ms(10);
			}

			Leds[91][1] = 0; Leds[91][2] = 0; Leds[91][3] = 0; 	Leds[92][1] = 0; Leds[92][2] = 0; Leds[92][3] = 0; 
			Leds[93][1] = 0; Leds[93][2] = 0; Leds[93][3] = 0; 	Leds[94][1] = 0; Leds[94][2] = 0; Leds[94][3] = 0; 
			UpdateLeds();
			
			ScanKeypad();
			if (Keypad[1] == 0)
			{
				Lost();
				goto start;
			}
//----------------------------------------------------------------------------------------------


//----------------------------------------------------------------------------------------------
			//PlaySound(2);
			Leds[64][1] = 255; Leds[64][2] = 0; Leds[64][3] = 0; 	Leds[65][1] = 255; Leds[65][2] = 0; Leds[65][3] = 0; 
			Leds[66][1] = 255; Leds[66][2] = 0; Leds[66][3] = 0; 	Leds[67][1] = 255; Leds[67][2] = 0; Leds[67][3] = 0; 
			UpdateLeds();
			iTimer = 0;
			while(iTimer < 50)
			{
				iTimer++;
				_delay_ms(10);
			}

			Leds[64][1] = 0; Leds[64][2] = 0; Leds[64][3] = 0; 	Leds[65][1] = 0; Leds[65][2] = 0; Leds[65][3] = 0; 
			Leds[66][1] = 0; Leds[66][2] = 0; Leds[66][3] = 0; 	Leds[67][1] = 0; Leds[67][2] = 0; Leds[67][3] = 0; 
			UpdateLeds();
			
			ScanKeypad();
			if (Keypad[6] == 0)
			{
				Lost();
				goto start;
			}
//----------------------------------------------------------------------------------------------



		//----------------------------------------------------------------------------------------------
			//PlaySound(2);
			Leds[36][1] = 0; Leds[36][2] = 255; Leds[36][3] = 0; 	Leds[37][1] = 0; Leds[37][2] = 255; Leds[37][3] = 0; //BLue
			Leds[38][1] = 0; Leds[38][2] = 255; Leds[38][3] = 0; 	Leds[39][1] = 0; Leds[39][2] = 255; Leds[39][3] = 0; 
			UpdateLeds();
			iTimer = 0;
			while(iTimer < 45)
			{
				iTimer++;
				_delay_ms(10);
			}

			Leds[36][1] = 0; Leds[36][2] = 0; Leds[36][3] = 0; 	Leds[37][1] = 0; Leds[37][2] = 0; Leds[37][3] = 0; 
			Leds[38][1] = 0; Leds[38][2] = 0; Leds[38][3] = 0; 	Leds[39][1] = 0; Leds[39][2] = 0; Leds[39][3] = 0; 
			UpdateLeds();
			
			ScanKeypad();
			if (Keypad[11] == 0)
			{
				Lost();
				goto start;
			}
//----------------------------------------------------------------------------------------------

			
			
		
		
		
		
				//----------------------------------------------------------------------------------------------
			//PlaySound(2);
			Leds[68][1] = 0; Leds[68][2] = 255; Leds[68][3] = 0; 	Leds[69][1] = 0; Leds[69][2] = 255; Leds[69][3] = 0; //BLue
			Leds[70][1] = 0; Leds[70][2] = 255; Leds[70][3] = 0; 	Leds[71][1] = 0; Leds[71][2] = 255; Leds[71][3] = 0; 
			UpdateLeds();
			iTimer = 0;
			while(iTimer < 40)
			{
				iTimer++;
				_delay_ms(10);
			}

			Leds[68][1] = 0; Leds[68][2] = 0; Leds[68][3] = 0; 	Leds[69][1] = 0; Leds[69][2] = 0; Leds[69][3] = 0; //BLue
			Leds[70][1] = 0; Leds[70][2] = 0; Leds[70][3] = 0; 	Leds[71][1] = 0; Leds[71][2] = 0; Leds[71][3] = 0; 
			UpdateLeds();
			
			ScanKeypad();
			if (Keypad[2] == 0)
			{
				Lost();
				goto start;
			}
//----------------------------------------------------------------------------------------------

//----------------------------------------------------------------------------------------------
			//PlaySound(2);
			Leds[64][1] = 255; Leds[64][2] = 0; Leds[64][3] = 0; 	Leds[65][1] = 255; Leds[65][2] = 0; Leds[65][3] = 0; 
			Leds[66][1] = 255; Leds[66][2] = 0; Leds[66][3] = 0; 	Leds[67][1] = 255; Leds[67][2] = 0; Leds[67][3] = 0; 
			UpdateLeds();
			iTimer = 0;
			while(iTimer < 35)
			{
				iTimer++;
				_delay_ms(10);
			}

			Leds[64][1] = 0; Leds[64][2] = 0; Leds[64][3] = 0; 	Leds[65][1] = 0; Leds[65][2] = 0; Leds[65][3] = 0; 
			Leds[66][1] = 0; Leds[66][2] = 0; Leds[66][3] = 0; 	Leds[67][1] = 0; Leds[67][2] = 0; Leds[67][3] = 0; 
			UpdateLeds();
			
			ScanKeypad();
			if (Keypad[6] == 0)
			{
				Lost();
				goto start;
			}
//----------------------------------------------------------------------------------------------



		//----------------------------------------------------------------------------------------------
			//PlaySound(2);
			Leds[36][1] = 0; Leds[36][2] = 255; Leds[36][3] = 0; 	Leds[37][1] = 0; Leds[37][2] = 255; Leds[37][3] = 0; //BLue
			Leds[38][1] = 0; Leds[38][2] = 255; Leds[38][3] = 0; 	Leds[39][1] = 0; Leds[39][2] = 255; Leds[39][3] = 0; 
			UpdateLeds();
			iTimer = 0;
			while(iTimer < 32)
			{
				iTimer++;
				_delay_ms(10);
			}

			Leds[36][1] = 0; Leds[36][2] = 0; Leds[36][3] = 0; 	Leds[37][1] = 0; Leds[37][2] = 0; Leds[37][3] = 0; 
			Leds[38][1] = 0; Leds[38][2] = 0; Leds[38][3] = 0; 	Leds[39][1] = 0; Leds[39][2] = 0; Leds[39][3] = 0; 
			UpdateLeds();
			
			ScanKeypad();
			if (Keypad[11] == 0)
			{
				Lost();
				goto start;
			}
//----------------------------------------------------------------------------------------------

			
			
		
		
		
		
				//----------------------------------------------------------------------------------------------
			//PlaySound(2);
			Leds[68][1] = 0; Leds[68][2] = 255; Leds[68][3] = 0; 	Leds[69][1] = 0; Leds[69][2] = 255; Leds[69][3] = 0; //BLue
			Leds[70][1] = 0; Leds[70][2] = 255; Leds[70][3] = 0; 	Leds[71][1] = 0; Leds[71][2] = 255; Leds[71][3] = 0; 
			UpdateLeds();
			iTimer = 0;
			while(iTimer < 30)
			{
				iTimer++;
				_delay_ms(10);
			}

			Leds[68][1] = 0; Leds[68][2] = 0; Leds[68][3] = 0; 	Leds[69][1] = 0; Leds[69][2] = 0; Leds[69][3] = 0; //BLue
			Leds[70][1] = 0; Leds[70][2] = 0; Leds[70][3] = 0; 	Leds[71][1] = 0; Leds[71][2] = 0; Leds[71][3] = 0; 
			UpdateLeds();
			
			ScanKeypad();
			if (Keypad[2] == 0)
			{
				Lost();
				goto start;
			}
//----------------------------------------------------------------------------------------------


//----------------------------------------------------------------------------------------------
		

				//----------------------------------------------------------------------------------------------
			//PlaySound(2);
			Leds[63][1] = 0; Leds[63][2] = 0; Leds[63][3] = 255; 	Leds[64][1] = 0; Leds[64][2] = 0; Leds[64][3] = 255; //Green
			Leds[65][1] = 0; Leds[65][2] = 0; Leds[65][3] = 255; 	Leds[66][1] = 0; Leds[66][2] = 0; Leds[66][3] = 255; 
			UpdateLeds();
			iTimer = 0;
			while(iTimer < 25)
			{
				iTimer++;
				_delay_ms(10);
			}

			Leds[63][1] = 0; Leds[63][2] = 0; Leds[63][3] = 0; 	Leds[64][1] = 0; Leds[64][2] = 0; Leds[64][3] = 0; //Green
			Leds[65][1] = 0; Leds[65][2] = 0; Leds[65][3] = 0; 	Leds[66][1] = 0; Leds[66][2] = 0; Leds[66][3] = 0;  
			UpdateLeds();
			
			ScanKeypad();
			if (Keypad[6] == 0)
			{
				Lost();
				goto start;
			}
//----------------------------------------------------------------------------------------------		
		
		
	//----------------------------------------------------------------------------------------------
			//PlaySound(2);
			Leds[36][1] = 0; Leds[36][2] = 255; Leds[36][3] = 0; 	Leds[37][1] = 0; Leds[37][2] = 255; Leds[37][3] = 0; //BLue
			Leds[38][1] = 0; Leds[38][2] = 255; Leds[38][3] = 0; 	Leds[39][1] = 0; Leds[39][2] = 255; Leds[39][3] = 0; 
			UpdateLeds();
			iTimer = 0;
			while(iTimer < 23)
			{
				iTimer++;
				_delay_ms(10);
			}

			Leds[36][1] = 0; Leds[36][2] = 0; Leds[36][3] = 0; 	Leds[37][1] = 0; Leds[37][2] = 0; Leds[37][3] = 0; 
			Leds[38][1] = 0; Leds[38][2] = 0; Leds[38][3] = 0; 	Leds[39][1] = 0; Leds[39][2] = 0; Leds[39][3] = 0; 
			UpdateLeds();
			
			ScanKeypad();
			if (Keypad[11] == 0)
			{
				Lost();
				goto start;
			}
//----------------------------------------------------------------------------------------------



















	}
			
			
			
			
			




			
		if ((PORTC.IN & PIN0_bm) == 0) 	{LcdClear();	LcdUpdate();	LcdGotoXYFont(1,1);		LcdStr(FONT_1X,"    SW0");		LcdUpdate();}	
		if ((PORTC.IN & PIN1_bm) == 0) 	{LcdClear();	LcdUpdate();	LcdGotoXYFont(1,1);		LcdStr(FONT_1X,"    SW1");		LcdUpdate();}
		if ((PORTC.IN & PIN2_bm) == 0) 	{LcdClear();	LcdUpdate();	LcdGotoXYFont(1,1);		LcdStr(FONT_1X,"    SW2");		LcdUpdate();}	
		if ((PORTC.IN & PIN3_bm) == 0) 	{LcdClear();	LcdUpdate();	LcdGotoXYFont(1,1);		LcdStr(FONT_1X,"    SW3");		LcdUpdate();}		
				
	}
}

void Lost()
{
	PlaySound(1);
	LcdClear();
	LcdUpdate();	
	LcdGotoXYFont(1,1);
	LcdStr(FONT_1X,"  You Lost");
	LcdGotoXYFont(1,3);
	LcdStr(FONT_1X,"  Press Start");
	LcdUpdate();
	while((PORTC.IN & PIN2_bm) != 0);
	
}

//--------------------------------------------------------------------------------------------------------
void UpdateLeds()
{
	// Alle leds
	for(int LedNum = 0; LedNum < 96; LedNum++)
	{
		for(int Bytes = 0; Bytes < 3; Bytes++)
		{
			for(int Bits = 0; Bits < 8; Bits++)
			{	
				//if (Leds[LedNum][Bytes] & (0b00000001 << Bits) == 1)
				if(Leds[LedNum][Bytes] & (1<<(7-Bits)))
				
				{
					//18 * nop
					PORTE.OUTSET   = PIN2_bm;
					
					asm volatile ("nop");asm volatile ("nop"); asm volatile ("nop"); asm volatile ("nop");
					asm volatile ("nop");asm volatile ("nop"); asm volatile ("nop"); asm volatile ("nop");
					asm volatile ("nop");asm volatile ("nop"); asm volatile ("nop"); asm volatile ("nop");
					asm volatile ("nop");asm volatile ("nop"); asm volatile ("nop"); asm volatile ("nop");

		
					PORTE.OUTCLR   = PIN2_bm;
					
					//15 * nop
					asm volatile ("nop");asm volatile ("nop"); asm volatile ("nop"); asm volatile ("nop");
					asm volatile ("nop");asm volatile ("nop"); asm volatile ("nop"); asm volatile ("nop");
					 asm volatile ("nop"); asm volatile ("nop");

				}
				else
				{
					//7 * nop
					PORTE.OUTSET   = PIN2_bm;
					asm volatile ("nop");asm volatile ("nop"); asm volatile ("nop"); asm volatile ("nop");
					
					PORTE.OUTCLR   = PIN2_bm;
					
					//21* nop
					asm volatile ("nop");asm volatile ("nop"); asm volatile ("nop"); asm volatile ("nop");
					asm volatile ("nop");asm volatile ("nop"); asm volatile ("nop"); asm volatile ("nop");
					 asm volatile ("nop"); asm volatile ("nop");
				
				}
			}
		}
	}
	_delay_us(50);
}


void PlaySound (uint8_t iFileNum)
{
	if (iFileNum & 0b00000001) PORTA.OUTCLR = PIN4_bm;
	else PORTA.OUTSET = PIN4_bm;
	if (iFileNum & 0b00000010) PORTA.OUTCLR = PIN3_bm;
	else PORTA.OUTSET = PIN3_bm;
	if (iFileNum & 0b00000100) PORTA.OUTCLR = PIN2_bm;
	else PORTA.OUTSET = PIN2_bm;
	if (iFileNum & 0b00010000) PORTA.OUTCLR = PIN1_bm;
	else PORTA.OUTSET = PIN1_bm;
	if (iFileNum & 0b00001000) PORTA.OUTCLR = PIN0_bm;
	else PORTA.OUTSET = PIN0_bm;
	
	//_delay_ms(2);
	
	//PORTA.OUTSET = PIN4_bm;
	//PORTA.OUTSET = PIN3_bm;
	//PORTA.OUTSET = PIN2_bm;
	//PORTA.OUTSET = PIN1_bm;
	//PORTA.OUTSET = PIN0_bm;
}

void InitGPIO()
{
	PORTA.DIRSET = PIN0_bm;	//Bit 4
	PORTA.DIRSET = PIN1_bm;	//Bit 5
	PORTA.DIRSET = PIN2_bm;	//Bit 3
	PORTA.DIRSET = PIN3_bm;	//Bit 2
	PORTA.DIRSET = PIN4_bm;	//Bit 1
	
	PORTA.OUTSET = PIN0_bm;	//Bit 4
	PORTA.OUTSET = PIN1_bm;	//Bit 5
	PORTA.OUTSET = PIN2_bm;	//Bit 3
	PORTA.OUTSET = PIN3_bm;	//Bit 2
	PORTA.OUTSET = PIN4_bm;	//Bit 1
	
	//A5 //Col 1
	//A6 //Col 2
	//A7 //Col 3
	//B0 //Col 4
	
	PORTA.DIRCLR = PIN5_bm;
	PORTA.DIRCLR = PIN6_bm;
	PORTA.DIRCLR = PIN7_bm;
	PORTB.DIRCLR = PIN0_bm;
	
	PORTA.PIN5CTRL = PORT_OPC_PULLDOWN_gc;
	PORTA.PIN6CTRL = PORT_OPC_PULLDOWN_gc;
	PORTA.PIN7CTRL = PORT_OPC_PULLDOWN_gc;
	PORTB.PIN0CTRL = PORT_OPC_PULLDOWN_gc;
	
	//B1	//Row 1
	//B2	//Row 2
	//B3	//Row 3
	//B4	//Row 4
	//B5	//Row 5
	//B6	//Row 6
	
	PORTB.DIRSET = PIN1_bm;
	PORTB.DIRSET = PIN2_bm;
	PORTB.DIRSET = PIN3_bm;
	PORTB.DIRSET = PIN4_bm;
	PORTB.DIRSET = PIN5_bm;
	PORTB.DIRSET = PIN6_bm;
	
	PORTB.OUTCLR  = PIN1_bm;
	PORTB.OUTCLR  = PIN2_bm;
	PORTB.OUTCLR  = PIN3_bm;
	PORTB.OUTCLR  = PIN4_bm;
	PORTB.OUTCLR  = PIN5_bm;
	PORTB.OUTCLR  = PIN6_bm;
	

	PORTC.DIRCLR = PIN0_bm;		//SW1
	PORTC.PIN0CTRL = PORT_OPC_PULLUP_gc;
	PORTC.DIRCLR = PIN1_bm;  	//SW2
	PORTC.PIN1CTRL = PORT_OPC_PULLUP_gc;
	PORTC.DIRCLR = PIN2_bm;		//SW3
	PORTC.PIN2CTRL = PORT_OPC_PULLUP_gc;
	PORTC.DIRCLR = PIN3_bm;		//SW4
	PORTC.PIN3CTRL = PORT_OPC_PULLUP_gc;


	PORTE.DIRSET = PIN2_bm;		//LedString
	PORTE.DIRSET = PIN3_bm;		//Led1
	PORTE.DIRSET = PIN4_bm;		//Led2
}


void resetArray()
{
	uint8_t iLocalCount = 0;
	
	    for(iLocalCount = 0; iLocalCount < 25; iLocalCount++)
	    {
		   Keypad[iLocalCount] = 0;
	    }
}


void ScanKeypad()
{
	resetArray();
	PORTB.DIRSET = PIN1_bm;
	PORTB.OUTSET = PIN1_bm;
	_delay_ms(10);
	if (PORTA.IN & PIN5_bm) Keypad[1] = 1;
	if (PORTA.IN & PIN6_bm) Keypad[2] = 1;
	if (PORTA.IN & PIN7_bm) Keypad[3] = 1;
	if (PORTB.IN & PIN0_bm) Keypad[4] = 1;
	PORTB.OUTCLR = PIN1_bm;
	PORTB.DIRCLR = PIN1_bm;
	
	PORTB.DIRSET = PIN2_bm;
	PORTB.OUTSET= PIN2_bm;
	_delay_ms(10);
	if (PORTA.IN & PIN5_bm) Keypad[5] = 1;
	if (PORTA.IN & PIN6_bm) Keypad[6] = 1;
	if (PORTA.IN & PIN7_bm) Keypad[7] = 1;
	if (PORTB.IN & PIN0_bm) Keypad[8] = 1;
	PORTB.OUTCLR = PIN2_bm;
	PORTB.DIRCLR = PIN2_bm;
	
	PORTB.DIRSET = PIN3_bm;
	PORTB.OUTSET= PIN3_bm;
	_delay_ms(10);
	if (PORTA.IN & PIN5_bm) Keypad[9] = 1;
	if (PORTA.IN & PIN6_bm) Keypad[10] = 1;
	if (PORTA.IN & PIN7_bm) Keypad[11] = 1;
	if (PORTB.IN & PIN0_bm) Keypad[12] = 1;
	PORTB.OUTCLR = PIN3_bm;
	PORTB.DIRCLR = PIN3_bm;
	
	PORTB.DIRSET = PIN4_bm;
	PORTB.OUTSET= PIN4_bm;
	_delay_ms(10);
	if (PORTA.IN & PIN5_bm) Keypad[13] = 1;
	if (PORTA.IN & PIN6_bm) Keypad[14] = 1;
	if (PORTA.IN & PIN7_bm) Keypad[15] = 1;
	if (PORTB.IN & PIN0_bm) Keypad[16] = 1;
	PORTB.OUTCLR = PIN4_bm;
	PORTB.DIRCLR = PIN4_bm;
	
	PORTB.DIRSET = PIN5_bm;
	PORTB.OUTSET= PIN5_bm;
	_delay_ms(10);
	if (PORTA.IN & PIN5_bm) Keypad[17] = 1;
	if (PORTA.IN & PIN6_bm) Keypad[18] = 1;
	if (PORTA.IN & PIN7_bm) Keypad[19] = 1;
	if (PORTB.IN & PIN0_bm) Keypad[20] = 1;
	PORTB.OUTCLR = PIN5_bm;
	PORTB.DIRCLR = PIN5_bm;
	
	PORTB.DIRSET = PIN6_bm;
	PORTB.OUTSET= PIN6_bm;
	_delay_ms(10);
	if (PORTA.IN & PIN5_bm) Keypad[21] = 1;
	if (PORTA.IN & PIN6_bm) Keypad[22] = 1;
	if (PORTA.IN & PIN7_bm) Keypad[23] = 1;
	if (PORTB.IN & PIN0_bm) Keypad[24] = 1;
	PORTB.OUTCLR = PIN6_bm;
	PORTB.DIRCLR = PIN6_bm;
}







//--------------------------------------------------------------------------------------------------------
void SetClock()
{
	// 32MHz
	CCP = CCP_IOREG_gc;
	OSC.CTRL |= OSC_RC32MEN_bm;                   // Enable internal 32 MHz oscillator
	while(!(OSC.STATUS & OSC_RC32MRDY_bm));       // Wait for oscillator is ready
	CCP = CCP_IOREG_gc;
	CLK.CTRL = CLK_SCLKSEL_RC32M_gc;              // Select sysclock 32 MHz oscillator
	
	// Calibrated with PPL based on 32KHz Internal
	CCP = CCP_IOREG_gc;
	OSC.CTRL       |= OSC_RC32KEN_bm;             // Enable internal 32 kHz oscillator
	while(!(OSC.STATUS & OSC_RC32KRDY_bm));       // Wait for oscillator is ready
	OSC.DFLLCTRL   &= ~(OSC_RC32MCREF_gm);        // Select 32 kHz calibration source
	OSC.DFLLCTRL   |=   OSC_RC32MCREF_RC32K_gc;   // for 32 MHz oscillator
	DFLLRC32M.CTRL |= DFLL_ENABLE_bm;             // Enable DFLL for 32 MHz oscillator
}



